/*!
  * Copyright 2016,  Digital Reasoning
  *
  * Licensed under the Apache License, Version 2.0 (the "License");
  * you may not use this file except in compliance with the License.
  * You may obtain a copy of the License at
  *
  *     http://www.apache.org/licenses/LICENSE-2.0
  *
  * Unless required by applicable law or agreed to in writing, software
  * distributed under the License is distributed on an "AS IS" BASIS,
  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  * See the License for the specific language governing permissions and
  * limitations under the License.
  *
*/

define(["jquery","knockout","bootbox","utils/utils"],function(t,e,r,o){"use strict";function i(t,r){var o=!1;"string"==typeof t&&(t=parseInt(t)),"number"==typeof t&&(o=!0,t={id:t,url:"/api/cloud/accounts/"+t+"/"}),this.raw=t,this.parent=r,this.id=t.id,this.title=e.observable(),this.description=e.observable(),this.slug=e.observable(),this.region=e.observable(),this.provider=e.observable(),this.vpcId=e.observable(),this.createSecurityGroups=e.observable(),this.properties=e.observable({}),this.hostDefinitions=e.observableArray([]),this.formulaVersions=e.observableArray([]),o?this.waiting=this.reload():this._process(t)}return i.constructor=i,i.prototype._process=function(t){this.title(t.title),this.description(t.description),this.slug(t.slug),this.region(t.region),this.provider(t.provider),this.vpcId(t.vpc_id),this.createSecurityGroups(t.create_security_groups)},i.prototype.reload=function(){var e=this;return t.ajax({method:"GET",url:this.raw.url}).done(function(t){e.raw=t,e._process(t)})},i.prototype.loadProperties=function(){var e=this;return this.raw.hasOwnProperty("properties")||(this.raw.properties=this.raw.url+"properties/"),t.ajax({method:"GET",url:this.raw.properties}).done(function(t){e.properties(t)})},i.prototype.saveProperties=function(){t.ajax({method:"PUT",url:this.raw.properties,data:JSON.stringify(this.properties())}).done(function(t){o.growlAlert("Successfully saved cloud account properties!","success")}).fail(function(t){var e;try{var r=JSON.parse(t.responseText);e=r.properties.join("<br>")}catch(i){e="Oops... there was a server error."}e+="  Your properties were not saved.",o.growlAlert(e,"danger")})},i.prototype.loadHostDefinitions=function(){function e(i){t.ajax({method:"GET",url:i}).done(function(t){o.push.apply(o,t.results.map(function(t){return new HostDefinition(t,r.parent)})),null===t.next?r.hostDefinitions(o):e(t.next)})}var r=this,o=[];e(this.raw.host_definitions)},i.prototype.save=function(){var e=this,r=["title","description","create_security_groups"];r.forEach(function(e){var r=t("#"+e);r.removeClass("has-error");var o=r.find(".help-block");o.remove()}),t.ajax({method:"PUT",url:e.raw.url,data:JSON.stringify({title:e.title(),description:e.description(),create_security_groups:e.createSecurityGroups()})}).done(function(t){o.growlAlert("Successfully saved cloud account!","success");try{e.parent.accountTitle(t.title)}catch(r){}}).fail(function(t){o.parseSaveError(t,"cloud account",r)})},i.prototype["delete"]=function(){var e=this,o=this.title();r.confirm({title:"Confirm delete of <strong>"+o+"</strong>",message:"Are you sure you want to delete <strong>"+o+"</strong>?",buttons:{confirm:{label:"Delete",className:"btn-danger"}},callback:function(o){o&&t.ajax({method:"DELETE",url:e.raw.url}).done(function(){"/accounts/"!==window.location.pathname?window.location="/accounts/":e.parent&&"function"==typeof e.parent.reload&&e.parent.reload()}).fail(function(t){var e;try{var o=JSON.parse(t.responseText);e=o.detail.join("<br>")}catch(i){e="Oops... there was a server error.  This has been reported to your administrators."}r.alert({title:"Error deleting cloud account",message:e})})}})},i});